using System;
using System.Runtime.CompilerServices;

public class HelloWorld
{
    public static void Main(string[] args)
    {
        string a = Console.ReadLine();
        string[] b = a.Split(' ');
        long N = long.Parse(b[0]);
        long Q = long.Parse(b[1]);
        long[] c = new long[2*N];
        long[] q1 = new long[Q];
        for (long i= 0; i<N*2; i++) 
        {
            string a1 = Console.ReadLine();
            string[] b1 = a1.Split(' ');
            c[i] = long.Parse(b1[0]);
            i++;
            c[i] = long.Parse(b1[1]);
        }
        for (long i = 0; i<Q ; i++)
        {
            string a2 = Console.ReadLine();
            q1[i]= long.Parse(a2);
        }
        for (long i = 0; i < Q; i++)
        {
            long resenje = 0; 
            long j = 0;
            long kratos = q1[i]; //k7
            long pozicija = 1;
            while (kratos > 0 && j<N)
            {
                if (c[j*2] <= q1[i])
                {
                kratos = kratos - (c[j*2]-pozicija); 
                pozicija = c[j*2]+1; 
                    if(kratos >= c[j*2+1])
                    {
                        resenje = resenje + c[j * 2 + 1]; 
                        kratos = kratos - c[j * 2 + 1];  
                    }
                    else
                    {
                        if (c[0] == 1)
                        {
                            resenje = resenje + kratos + 1;
                        }
                        else
                        {
                            resenje= resenje + kratos;
                        }
                        kratos = 0;
                    }
                }
                else
                {
                    kratos = 0;
                }
                j++; 
            }            
                Console.WriteLine(resenje);
        }
    }
}